#ifndef PRINTPANEL_H
#define PRINTPANEL_H

/************************************************************************
*   printPanel.h:
*   global externs for the check printing panel
*   
*************************************************************************/

/* gadget enumerations */
enum
{
    GID_PRPRINTMODE,
    GID_PRAUTOVOID,
    GID_PRCHECKPAGE,
    GID_PRCHECKSTART,
    GID_PROK,
    GID_PRCANCEL,
};


#define MAXCHECKLINES	130
#define MAXCHECKCOLS	130

#define CHECKGRID(r,c)	checkImage[(r)*alloccolumns + (c)]

                       
/* layout structures */
extern GadgetSpec *PR_PrintSpecs[];
extern ULONG PR_PrintPanel[];
extern GUIFront *printGUI; 
extern struct Window *printWindow;
extern char *checkImage;

void PrintGUI(void);
BOOL PrintItem(FILE *out,filterNode *filt, formControl *forms, BOOL test, BOOL page1, int *lastone);
char *PrintCheckAlloc(checkForm *);
#endif
