#ifndef QDATEPANEL_H
#define QDATEPANEL_H

/************************************************************************
*   qdatePanel.h:
*   global externs for the quick date panel
*   
*************************************************************************/

/* gadget enumerations */
enum
{
    GID_QDATELIST,
    GID_QDATEDAYSLIDE,
    GID_QDATEMONTHSLIDE,
    GID_QDATEYEARSLIDE,
    GID_QDATEDAY,
    GID_QDATEMONTH,
    GID_QDATEYEAR,
    GID_QDATEOK
};


/* tags */
                       
/* layout structures */
extern GadgetSpec *QD_DateSpecs[];
extern ULONG QD_DatePanel[];
extern GUIFront *qdateGUI; 
extern struct Window *qdateWin;
extern ULONG qdateSel;
extern BOOL easydate;
extern dateType edate;

BOOL QDateGUI(char *);
void QDateAdd(dateType *date);
void QDateNewFormat(void);
#endif
